//+------------------------------------------------------------------+
//|                                                  WorkSection.mqh |
//|                               Copyright 2019, Vladimir Mikhailov |
//|                                                mikh.vl@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, Vladimir Mikhailov"
#property link      "mikh.vl@gmail.com"
#property version   "1.00"
enum ENUM_WORK_SECTION
   {
    WORK_CLOSE=0,
    WORK_TRACKING=1,
    WORK_OPEN=2
   };
//+------------------------------------------------------------------+
//|  CWorkSection                                                    |
//+------------------------------------------------------------------+
class CWorkSection
  {
   struct SWorkSection
      {
       ENUM_WORK_SECTION section;
       int               start_hour;
       int               start_min;
       int               end_hour;
       int               end_min;
      };
      
private:
   SWorkSection      m_section[];

public:
   void              Init(void);
   void              DeInit(void);
   ENUM_WORK_SECTION GetSection(void);
  };
//+------------------------------------------------------------------+
//|  Init                                                            |
//+------------------------------------------------------------------+
void CWorkSection::Init()
  {
   ArrayResize(m_section,3);
   m_section[0].section=WORK_CLOSE;
   m_section[0].start_hour=10;
   m_section[0].start_min=2;
   m_section[0].end_hour=10;
   m_section[0].end_min=15;
//---
   m_section[1].section=WORK_TRACKING;
   m_section[1].start_hour=10;
   m_section[1].start_min=0;
   m_section[1].end_hour=18;
   m_section[1].end_min=39;
//---
   m_section[2].section=WORK_OPEN;
   m_section[2].start_hour=18;
   m_section[2].start_min=39;
   m_section[2].end_hour=18;
   m_section[2].end_min=45;
  }
//+------------------------------------------------------------------+
//|  DeInit                                                          |
//+------------------------------------------------------------------+
void CWorkSection::DeInit(void)
   {
    ArrayFree(m_section);
   }
//+------------------------------------------------------------------+
//|  GetSection                                                      |
//+------------------------------------------------------------------+
ENUM_WORK_SECTION CWorkSection::GetSection(void)
  {
   ENUM_WORK_SECTION section=-1;
   int s=ArraySize(m_section);
   MqlDateTime current_stime;
   datetime current_time, start_time, end_time;
   current_time=TimeTradeServer(current_stime);
   for(int i=0;i<s;i++)
      {
       current_stime.hour=m_section[i].start_hour;
       current_stime.min=m_section[i].start_min;
       current_stime.sec=0;
       start_time=StructToTime(current_stime);
   
       current_stime.hour=m_section[i].end_hour;
       current_stime.min=m_section[i].end_min;
       current_stime.sec=0;
       end_time=StructToTime(current_stime);
       
       if(current_time>=start_time && current_time<end_time)
         {
          section=m_section[i].section;
          break;
         }
      }
   return(section);
  }
//+------------------------------------------------------------------+
